import "core-js/modules/es.array.concat.js";
import { useEffect, useMemo } from '@storybook/addons';
import { DEFAULT_PADDING, PARAM_KEY } from './constants';
import { isReducedMotionPreferred, getSelectedPadding, normalizeValues } from './helpers';

var setStyle = function setStyle(selector, css) {
  var existingStyle = document.getElementById(selector);

  if (existingStyle) {
    if (existingStyle.innerHTML !== css) {
      existingStyle.innerHTML = css;
    }
  } else {
    var style = document.createElement('style');
    style.setAttribute('id', selector);
    style.innerHTML = css;
    document.head.appendChild(style);
  }
};

var WithPaddings = function WithPaddings(getStory, context) {
  var _globals$PARAM_KEY;

  var id = context.id,
      globals = context.globals,
      parameters = context.parameters,
      viewMode = context.viewMode;
  var globalsSelectedPadding = (_globals$PARAM_KEY = globals[PARAM_KEY]) == null ? void 0 : _globals$PARAM_KEY.value;
  var paddingsConfig = parameters[PARAM_KEY];
  var isInDocs = viewMode === 'docs';
  var selector = isInDocs ? "#anchor--".concat(id, " .docs-story > div:first-child") : '.sb-show-main';
  var selectedPadding = useMemo(function () {
    var _getSelectedPadding;

    return (_getSelectedPadding = getSelectedPadding(normalizeValues(paddingsConfig), globalsSelectedPadding)) != null ? _getSelectedPadding : DEFAULT_PADDING;
  }, [paddingsConfig, globalsSelectedPadding]);
  var paddingStyles = useMemo(function () {
    return "\n      ".concat(selector, " {\n        margin: 0;\n        padding: ").concat(selectedPadding, " !important;\n        ").concat(isReducedMotionPreferred() ? '' : 'transition: padding .3s;', "\n      }\n\n      ").concat(selector, " .innerZoomElementWrapper > div {\n        border-width: 0 !important;\n      }\n    ");
  }, [selector, selectedPadding]);
  useEffect(function () {
    var selectorId = isInDocs ? "addon-paddings-docs-".concat(id) : "addon-paddings";
    setStyle(selectorId, paddingStyles);
  }, [id, isInDocs, paddingStyles]);
  return getStory(context);
};

export default WithPaddings;